unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, ExtCtrls, Unit2;

type

  TNodePtr = ^TNode;
  TNode = Object
    RecCount    :integer;
    ParentPtr   :TNodePtr;
    LeftNodePtr :TNodePtr;
    RightNodePtr:TNodePtr;
    KeyValue:string;
    procedure ClearNode;
  end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    CheckListBox1: TCheckListBox;
    Button5: TButton;
    GroupBox1: TGroupBox;
    Button6: TButton;
    Panel1: TPanel;
    Button10: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Panel2: TPanel;
    Frame21: TFrame2;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1:TForm1;
  Root ,Current:TNodePtr;

implementation

{$R *.dfm}

function FindNode(var RootPtr:TNodePtr;Key,Data:string;var RetNode:TNodePtr):boolean;
var NodePtr:TNodePtr;
begin
  result := FALSE;
  NodePtr := RootPtr;
    while(NodePtr <> nil)do
      begin
        if(Key = NodePtr^.KeyValue)then
          begin
            result := TRUE;
            if(@RetNode <> nil)then
              RetNode := NodePtr;
            //ShowMessage('Find !! ('+NodePtr^.KeyValue+') !!');
            Break;
          end;//if...end!!
        //---------------------------------------------------------------
        if(Key > NodePtr^.KeyValue)then NodePtr := NodePtr^.RightNodePtr
        else
          if(Key < NodePtr^.KeyValue)then NodePtr := NodePtr^.LeftNodePtr;
      end;//if...end!!
end;

function IsRightPtr(ParentNodePtr,ChildNodePtr:TNodePtr):boolean;
begin
  result := FALSE;
  if(ParentNodePtr = nil)then Exit;
  if(ParentNodePtr^.LeftNodePtr  = ChildNodePtr)then Exit;
  if(ParentNodePtr^.RightNodePtr = ChildNodePtr)then
    result := TRUE;
end;

function IsLeftPtr(ParentNodePtr,ChildNodePtr:TNodePtr):boolean;
begin
  result := FALSE;
  if(ParentNodePtr = nil)then Exit;
  if(ParentNodePtr^.RightNodePtr = ChildNodePtr)then Exit;
  if(ParentNodePtr^.LeftNodePtr  = ChildNodePtr)then
    result := TRUE;
end;

function FindSmallerNodePtr(ParentNodePtr:TNodePtr):TNodePtr;
var tmpNodePtr:TNodePtr;
begin
  result := nil;
  if(ParentNodePtr = nil)then Exit;
  tmpNodePtr := ParentNodePtr;
  while(tmpNodePtr^.LeftNodePtr <> nil)do
    tmpNodePtr := tmpNodePtr^.LeftNodePtr;
  result := tmpNodePtr;  
end;

function FindBigerNodePtr(ParentNodePtr:TNodePtr):TNodePtr;
var tmpNodePtr:TNodePtr;
begin
  result := nil;
  if(ParentNodePtr = nil)then Exit;
  tmpNodePtr := ParentNodePtr;
  while(tmpNodePtr^.RightNodePtr <> nil)do
    tmpNodePtr := tmpNodePtr^.RightNodePtr;
  result := tmpNodePtr;  
end;

function FindNextNodePtr(CurrentNodePtr:TNodePtr):TNodePtr;
var tmpPtr:TNodePtr;
    tmpKeyStr:string;
begin
  result := nil;
  if(CurrentNodePtr = nil)then Exit;
  if(CurrentNodePtr^.RightNodePtr = nil)then
    begin
      if(IsLeftPtr(CurrentNodePtr^.ParentPtr,CurrentNodePtr) = TRUE)then
        result := CurrentNodePtr^.ParentPtr
      else
        begin
          tmpKeyStr := CurrentNodePtr^.KeyValue;
          tmpPtr    := CurrentNodePtr;
          while(tmpPtr^.ParentPtr <> nil)do
            begin
              if(tmpPtr^.ParentPtr^.KeyValue < tmpKeyStr)then
                tmpPtr := tmpPtr^.ParentPtr
              else
                begin
                  result := tmpPtr^.ParentPtr;
                  Break;
                end;//else...end!!
            end;//while...end!!
        end;//else...end!!
    end//if...end!!
  else
    begin
      tmpPtr := FindSmallerNodePtr(CurrentNodePtr^.RightNodePtr);
      if(tmpPtr = nil)then result := CurrentNodePtr^.RightNodePtr
      else result := tmpPtr;
    end;//if...else...end!!
end;

function FindPriorNodePtr(CurrentNodePtr:TNodePtr):TNodePtr;
var tmpPtr:TNodePtr;
    tmpKeyStr:string;
begin
  result := nil;
  if(CurrentNodePtr = nil)then Exit;
  if(CurrentNodePtr^.LeftNodePtr = nil)then
    begin
      if(IsRightPtr(CurrentNodePtr^.ParentPtr,CurrentNodePtr) = TRUE)then
        result := CurrentNodePtr^.ParentPtr
      else
        begin
          tmpKeyStr := CurrentNodePtr^.KeyValue;
          tmpPtr    := CurrentNodePtr;
          while(tmpPtr^.ParentPtr <> nil)do
            begin
              if(tmpPtr^.ParentPtr^.KeyValue > tmpKeyStr)then
                tmpPtr := tmpPtr^.ParentPtr
              else
                begin
                  result := tmpPtr^.ParentPtr;
                  Break;
                end;//else...end!!
            end;//while...end!!  
        end;//else...end!!
    end//if...end!!
  else
    begin
      tmpPtr := FindBigerNodePtr(CurrentNodePtr^.LeftNodePtr);
      if(tmpPtr = nil)then result := CurrentNodePtr^.LeftNodePtr
      else result := tmpPtr;
    end;//if...else...end!!
end;

function FindFirstNodePtr(CurrentNodePtr:TNodePtr):TNodePtr;
var tmpPtr,PriorPtr:TNodePtr;
begin
  result := nil;
  tmpPtr := CurrentNodePtr;
  PriorPtr := FindPriorNodePtr(tmpPtr);
  while(PriorPtr <> nil)do
    begin
      tmpPtr := PriorPtr;
      PriorPtr := FindPriorNodePtr(tmpPtr);
    end;//while...end!!
  result := tmpPtr;
end;

function FindLastNodePtr(CurrentNodePtr:TNodePtr):TNodePtr;
var tmpPtr,NextPtr:TNodePtr;
begin
  result := nil;
  tmpPtr := CurrentNodePtr;
  NextPtr := FindNextNodePtr(tmpPtr);
  while(NextPtr <> nil)do
    begin
      tmpPtr  := NextPtr;
      NextPtr := FindNextNodePtr(tmpPtr);
    end;//while...end!!
  result := tmpPtr;
end;

function DeleteNode(var RootPtr:TNodePtr;Key,Data:string):boolean;
var NewRootPtr,tmpPtr,NodePtr:TNodePtr;
begin
  result := FALSE;
  NodePtr := RootPtr;
  if(RootPtr = nil)then Exit;
  if(Key <> RootPtr^.KeyValue)then
    begin
        while(NodePtr <> nil)do
          begin
            if(Key = NodePtr^.KeyValue)then
              begin
                if(IsLeftPtr(NodePtr^.ParentPtr,NodePtr) = TRUE)then
                  begin
                    //debug ShowMessage('Delete Node Is LeftNode !! ');
                    if(NodePtr^.LeftNodePtr <> nil)then
                      begin
                        NodePtr^.LeftNodePtr^.ParentPtr := NodePtr^.ParentPtr;
                        NodePtr^.ParentPtr^.LeftNodePtr := NodePtr^.LeftNodePtr;
                        if(NodePtr^.RightNodePtr <> nil)then
                          begin
                            tmpPtr := nil;
                            tmpPtr := FindBigerNodePtr(NodePtr^.LeftNodePtr);
                            if(tmpPtr <> nil)then
                              begin
                                tmpPtr^.RightNodePtr := NodePtr^.RightNodePtr;
                                NodePtr^.RightNodePtr^.ParentPtr := tmpPtr;
                                tmpPtr := nil;
                              end //if...end!!
                            else
                              begin
                                NodePtr^.LeftNodePtr^.RightNodePtr := NodePtr^.RightNodePtr;
                                NodePtr^.RightNodePtr^.ParentPtr := NodePtr^.LeftNodePtr;
                              end;//else...end!!
                          end;//if...end!!
                      end //if...end!!
                    else
                      begin
                        NodePtr^.ParentPtr^.LeftNodePtr := NodePtr^.RightNodePtr;
                        if(NodePtr^.RightNodePtr <> nil)then
                          NodePtr^.RightNodePtr.ParentPtr := NodePtr^.ParentPtr;
                      end; //if...end!!
                  end //if...end!!
                else
                  if(IsRightPtr(NodePtr^.ParentPtr,NodePtr) = TRUE)then
                    begin
                      //debug ShowMessage('Delete Node Is RightNode !! ');
                      if(NodePtr^.LeftNodePtr <> nil)then
                        begin
                          NodePtr^.ParentPtr^.RightNodePtr := NodePtr^.LeftNodePtr;
                          NodePtr^.LeftNodePtr^.ParentPtr  := NodePtr^.ParentPtr;
                          if(NodePtr^.RightNodePtr <> nil)then
                            begin
                              tmpPtr := nil;
                              tmpPtr := FindBigerNodePtr(NodePtr^.LeftNodePtr);
                              if(tmpPtr <> nil)then
                                begin
                                  tmpPtr^.RightNodePtr := NodePtr^.RightNodePtr;
                                  NodePtr^.RightNodePtr^.ParentPtr := tmpPtr;
                                  tmpPtr := nil;
                                end//if...end!!
                              else
                                begin
                                  NodePtr^.LeftNodePtr^.RightNodePtr := NodePtr^.RightNodePtr;
                                  NodePtr^.RightNodePtr^.ParentPtr   := NodePtr^.LeftNodePtr;
                                end;//if...else...end!!
                            end;//if...end!!
                        end //if...end!!
                      else
                        begin
                          NodePtr^.ParentPtr^.RightNodePtr := NodePtr^.RightNodePtr;
                          if(NodePtr^.RightNodePtr <> nil)then
                            NodePtr^.RightNodePtr^.ParentPtr := NodePtr^.ParentPtr;
                        end;//if...else...end!!
                    end; //if...end!!
                RootPtr^.RecCount := RootPtr^.RecCount-1;
                //debug !! ShowMessage('Delete !! ('+NodePtr^.KeyValue+') !!');
                DisPose(NodePtr);
                result := TRUE;
                Break;
              end;//if...end!!
            //-----------------------------------------------------------------
            if(Key > NodePtr^.KeyValue)then  NodePtr := NodePtr^.RightNodePtr
            else
              if(Key < NodePtr^.KeyValue)then NodePtr := NodePtr^.LeftNodePtr;
          end;//while...end!!

    end//if...end!!
  else   //if Delete Node is Root !!
    begin
      if(RootPtr^.RightNodePtr <> nil)then
        begin
          NewRootPtr := RootPtr^.RightNodePtr;
          if(RootPtr^.RightNodePtr^.LeftNodePtr = nil)then
            begin
              if(RootPtr^.LeftNodePtr <> nil)then
                begin
                  RootPtr^.RightNodePtr^.LeftNodePtr := RootPtr^.LeftNodePtr;
                  RootPtr^.LeftNodePtr^.ParentPtr := RootPtr^.RightNodePtr;
                end;//if...end!!
            end//if...end!!
          else //if(RootPtr^.RightNodePtr^.LeftNodePtr <> nil)
            begin
              tmpPtr := RootPtr^.RightNodePtr^.LeftNodePtr;
              while(tmpPtr^.LeftNodePtr <> nil)do
                tmpPtr := tmpPtr^.LeftNodePtr;
              if(tmpPtr^.LeftNodePtr = nil)then
                begin
                  tmpPtr^.LeftNodePtr := RootPtr^.LeftNodePtr;
                  if(RootPtr^.LeftNodePtr <> nil)then
                    RootPtr^.LeftNodePtr^.ParentPtr := tmpPtr;
                  tmpPtr := nil;
                end; //if...end!!
              tmpPtr := nil;  
            end;//else...end!!
          RootPtr^.RightNodePtr^.ParentPtr   := nil;
          RootPtr^.RightNodePtr^.RecCount    := RootPtr^.RecCount-1;
          //debug !! ShowMessage('Delete !! ('+RootPtr^.KeyValue+') !!');
          Dispose(RootPtr);
          RootPtr := nil;
          RootPtr := NewRootPtr;
          tmpPtr  := nil;
          result  := TRUE;
        end //if...end!!
      else
        //RootPtr^.RightNodePtr = nil
        begin
          if(RootPtr^.LeftNodePtr <> nil)then
            begin
              NewRootPtr := RootPtr^.LeftNodePtr;
              NewRootPtr^.ParentPtr := nil;
              NewRootPtr^.RecCount := RootPtr^.RecCount-1;
              //debug !! ShowMessage('Delete !! ('+RootPtr^.KeyValue+') !!');
              Dispose(RootPtr);
              RootPtr := nil;
              RootPtr := NewRootPtr;
              tmpPtr  := nil;
              result := TRUE;
            end //if...end!!
          else //Left is Nil and Right is Nill
            begin
              //debug !! ShowMessage('Delete !! ('+RootPtr^.KeyValue+') !!');
              Dispose(RootPtr);
              RootPtr := nil;
              result := TRUE;
            end;//else...end!!
        end;//else...end!!
    end;//else...end!!
end;

function InsertDataToBTree(var RootPtr:TNodePtr;Key:string):boolean;
var NodePtr:TNodePtr;
    InsertSuccess:boolean;
begin
  result := FALSE;
  InsertSuccess := FALSE;
  if(RootPtr = nil)then
    begin
       New(RootPtr);
       RootPtr^.ClearNode;
       RootPtr^.RecCount := 1;
       RootPtr^.KeyValue := Key;
       result := TRUE;
    end//if...end!!
  else
    begin
      NodePtr := RootPtr;
      while(InsertSuccess = FALSE)do
        begin
          if(Key < NodePtr^.KeyValue)then
            begin
              if(NodePtr^.LeftNodePtr = nil)then
                begin
                  New(NodePtr^.LeftNodePtr);
                  NodePtr^.LeftNodePtr^.ClearNode;
                  NodePtr^.LeftNodePtr^.ParentPtr := NodePtr;
                  NodePtr^.LeftNodePtr^.KeyValue  := Key;
                  RootPtr^.RecCount := RootPtr^.RecCount+1;
                  InsertSuccess := TRUE;
                end //if...end!!
              else
                NodePtr := NodePtr^.LeftNodePtr;
            end//if...end!!
          else
            if(Key = NodePtr^.KeyValue)then
              begin
                //show Error Message();
                Break;
              end//if...end!!
            else
              if(Key > NodePtr^.KeyValue)then
                begin
                  if(NodePtr^.RightNodePtr = nil)then
                    begin
                      New(NodePtr^.RightNodePtr);
                      NodePtr^.RightNodePtr^.ClearNode;
                      NodePtr^.RightNodePtr^.ParentPtr := NodePtr;
                      NodePtr^.RightNodePtr^.KeyValue  := Key;
                      RootPtr^.RecCount := RootPtr^.RecCount+1;
                      InsertSuccess := TRUE;
                    end//if...end!!
                  else
                    NodePtr := NodePtr^.RightNodePtr;
                end;//if...end!!
        end;//while...end!!
      NodePtr := nil;
      result := InsertSuccess;
    end;//else...end!!
end;

procedure DestroyTree(var RootPtr:TNodePtr);
var tmpNodePtr,TargetNodePtr:TNodePtr;
    str:string;
begin
  if(RootPtr = nil)then Exit;
  TargetNodePtr := RootPtr;
  while(TargetNodePtr <> nil)do
    begin
      if(TargetNodePtr^.LeftNodePtr = nil)
      and(TargetNodePtr^.RightNodePtr = nil)then
        begin
          tmpNodePtr := TargetNodePtr^.ParentPtr;
          if(tmpNodePtr <> nil)then
            begin
              if(TargetNodePtr = tmpNodePtr^.LeftNodePtr)then
                tmpNodePtr^.LeftNodePtr := nil;
              if(TargetNodePtr = tmpNodePtr^.RightNodePtr)then
                tmpNodePtr^.RightNodePtr := nil;
              str := TargetNodePtr^.ParentPtr.KeyValue;
            end//if...end!!
          else
            begin
              RootPtr := nil;
              str := 'nil';
            end;//else...end!!
          //debug!! ShowMessage('Free '+TargetNodePtr^.KeyValue
          //       +#10+#13
          //       +'Parent '+str);
          DisPose(TargetNodePtr);
          TargetNodePtr := tmpNodePtr;
          tmpNodePtr := nil;
        end//if...end!!
      else
        begin
          while(TargetNodePtr^.LeftNodePtr <> nil)do
            TargetNodePtr := TargetNodePtr^.LeftNodePtr;
          //------------------------------------------------
          while(TargetNodePtr^.RightNodePtr <> nil)do
            begin
              TargetNodePtr := TargetNodePtr^.RightNodePtr;
              while(TargetNodePtr^.LeftNodePtr <> nil)do
                TargetNodePtr := TargetNodePtr^.LeftNodePtr;
            end;//if...end!!
        end;//else...end!!
    end;//while...end!!    
end;

//TNode.
procedure TNode.ClearNode;
begin
  self.RecCount       := 0;
  self.KeyValue       := '';
  self.LeftNodePtr    := nil;
  self.RightNodePtr   := nil;
  self.ParentPtr      := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if(InsertDataToBTree(Root,Edit1.Text) = TRUE)then
    Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
end;

procedure TForm1.Button3Click(Sender: TObject);
var tmpNodePtr:TNodePtr;
begin
  if(FindNode(Root,Edit3.Text,'',tmpNodePtr) = TRUE)then
    begin
      Current := tmpNodePtr;
      Frame21.ClearInfo;
      if(tmpNodePtr^.ParentPtr <> nil)then
        Frame21.PutParentNode(tmpNodePtr^.ParentPtr^.KeyValue);

      Frame21.PutCurrentNode(tmpNodePtr^.KeyValue);

      if(tmpNodePtr^.LeftNodePtr <> nil)then
        Frame21.PutLeftNode(tmpNodePtr^.LeftNodePtr^.KeyValue);

      if(tmpNodePtr^.RightNodePtr <> nil)then
        Frame21.PutRightNode(tmpNodePtr^.RightNodePtr^.KeyValue);
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var id:integer;
begin
  id := ListBox1.Items.IndexOf(Edit3.Text);
  if(DeleteNode(Root,Edit3.Text,'') = TRUE)then
    begin
      Current := nil;
      ListBox1.Items.Delete(id);
      if(root = nil)then Label3.Caption := 'Record Count = 0'
      else Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
      Button5.Click;
      ListBox1.ItemIndex := 0;
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DestroyTree(Root);
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:integer;
begin
  for i := 0 to ListBox1.Items.Count-1 do
    begin
      ListBox1.ItemIndex := i;
      if(InsertDataToBTree(Root,ListBox1.Items[i]) = TRUE)then
        Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
    end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if(ListBox1.ItemIndex >= 0)then
    begin
      Edit3.Text := ListBox1.Items[ListBox1.ItemIndex];
      Button3.Click;
    end;//if...end!!  
end;

procedure TForm1.Button5Click(Sender: TObject);
var i:integer;
    tmpPtr:TNodePtr;
begin
  CheckListBox1.Items.Clear;
  CheckListBox1.Items.AddStrings(ListBox1.Items);
  for i := 0 to CheckListBox1.Items.Count-1 do
    begin
      CheckListBox1.ItemIndex := i;
      if(FindNode(Root,CheckListBox1.Items[i],'',tmpPtr) = TRUE)then
        CheckListBox1.Checked[i] := TRUE;
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  DestroyTree(Root);
end;

procedure TForm1.Button7Click(Sender: TObject);
var tmpPtr:TNodePtr;
begin
  if(Current = nil)then Exit
  else
    begin
      tmpPtr := nil;
      tmpPtr := FindPriorNodePtr(Current);
      if(tmpPtr = nil)then Exit;
      Frame21.ClearInfo;

      if(tmpPtr^.ParentPtr <> nil)then
        Frame21.PutParentNode(tmpPtr^.ParentPtr^.KeyValue);

      Frame21.PutCurrentNode(tmpPtr^.KeyValue);

      if(tmpPtr^.LeftNodePtr <> nil)then
        Frame21.PutLeftNode(tmpPtr^.LeftNodePtr^.KeyValue);

      if(tmpPtr^.RightNodePtr <> nil)then
        Frame21.PutRightNode(tmpPtr^.RightNodePtr^.KeyValue);
        
      Current := tmpPtr;
      tmpPtr := nil;
    end;    
end;

procedure TForm1.Button8Click(Sender: TObject);
var tmpPtr:TNodePtr;
begin
  if(Current = nil)then Exit
  else
    begin
      tmpPtr := nil;
      tmpPtr := FindNextNodePtr(Current);
      if(tmpPtr = nil)then Exit;
      Frame21.ClearInfo;

      if(tmpPtr^.ParentPtr <> nil)then
        Frame21.PutParentNode(tmpPtr^.ParentPtr^.KeyValue);

      Frame21.PutCurrentNode(tmpPtr^.KeyValue);

      if(tmpPtr^.LeftNodePtr <> nil)then
        Frame21.PutLeftNode(tmpPtr^.LeftNodePtr^.KeyValue);

      if(tmpPtr^.RightNodePtr <> nil)then
        Frame21.PutRightNode(tmpPtr^.RightNodePtr^.KeyValue);
      Current := tmpPtr;
      tmpPtr := nil;
    end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var tmpPtr:TNodePtr;
begin
  if(Current = nil)then Exit
  else
    begin
      tmpPtr := nil;
      tmpPtr := FindLastNodePtr(Current);
      if(tmpPtr = nil)then Exit;
      Frame21.ClearInfo;

      if(tmpPtr^.ParentPtr <> nil)then
        Frame21.PutParentNode(tmpPtr^.ParentPtr^.KeyValue);

      Frame21.PutCurrentNode(tmpPtr^.KeyValue);

      if(tmpPtr^.LeftNodePtr <> nil)then
        Frame21.PutLeftNode(tmpPtr^.LeftNodePtr^.KeyValue);

      if(tmpPtr^.RightNodePtr <> nil)then
        Frame21.PutRightNode(tmpPtr^.RightNodePtr^.KeyValue);
      Current := tmpPtr;
      tmpPtr := nil;
    end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var tmpPtr:TNodePtr;
begin
  if(Current = nil)then Exit
  else
    begin
      tmpPtr := nil;
      tmpPtr := FindFirstNodePtr(Current);
      if(tmpPtr = nil)then Exit;
      Frame21.ClearInfo;

      if(tmpPtr^.ParentPtr <> nil)then
        Frame21.PutParentNode(tmpPtr^.ParentPtr^.KeyValue);

      Frame21.PutCurrentNode(tmpPtr^.KeyValue);

      if(tmpPtr^.LeftNodePtr <> nil)then
        Frame21.PutLeftNode(tmpPtr^.LeftNodePtr^.KeyValue);

      if(tmpPtr^.RightNodePtr <> nil)then
        Frame21.PutRightNode(tmpPtr^.RightNodePtr^.KeyValue);

      Current := tmpPtr;
      tmpPtr := nil;
    end;
end;

end.
